<?php
define('SID_NAME', 'CVUT_A030_A122');
session_name(SID_NAME);
session_start();

define('LIBS_PATH', '../libs/');

# database setting and support

define('DBHOST', 'peta-esru.mecheng.strath.ac.uk');
define('DBUSER', 'manager');
define('DBNAME', 'smarthomes');
define('DBPWD', 'manager');
#define('DBPORT', '');

require_once(LIBS_PATH.'DBsupport.lib.php');

# language setting
if (!isset($_SESSION['lang'])) $_SESSION['lang'] = 'cz';
if (isset($_GET['lang']) && $_GET['lang'] != $_SESSION['lang']) $_SESSION['lang'] = $_GET['lang'];

# service setting
define('HTTPS', 1); // http + ssl
define('SECURITY_SERVICE', 1); // login dialog
define('MAX_NO_ACTIVITY_TIME', 20); // in minutes
define('MOD_LOGIN', 'login');
define('MOD_LOGIN_CHECK', 'loginchck');
define('MOD_LOGOUT', 'logout');
define('MOD_CURRENT', 1);
define('MOD_TABLES', 2);
define('MOD_HISTORY', 3);
define('MOD_AVG', 4);
define('MOD_COMPARISON', 5);

$site = null;
if (isset($_GET['site'])) {
	$site = $_GET['site'];
	unset($_GET['site']);
}

$libScriptName = '';
$localScriptName = '';

switch ($site) {
	case MOD_TABLES:
		$libScriptName = 'tables';
		$title = array('cz' => 'Tabulky prbh mench veliin', 'en' => 'Tables with measured values');
		break;
	case MOD_HISTORY:
		$libScriptName = 'history';
		$title = array('cz' => 'Prbhy mench veliin', 'en' => 'Measured values history');
		break;
	case MOD_AVG:
		$libScriptName = 'avg';
		$title = array('cz' => 'Prmrn hodnoty mench veliin', 'en' => 'Average values');
		break;
	case MOD_COMPARISON:
		$libScriptName = 'comparison';
		$title = array('cz' => 'Porovnn prbh mench veliin', 'en' => 'History comparison');
		break;
	case MOD_LOGIN_CHECK:
		$_SESSION["lastActivityTime"] = 0;
		if (md5($_POST["uzivatel"]) == '1d0258c2440a8d19e716292b231e3190' && md5($_POST["heslo"]) == '1d0258c2440a8d19e716292b231e3190') {
			$_SESSION["lastActivityTime"] = time();
		} else {
			header('Location: index.php?site='.MOD_LOGOUT.'&access=denied');
			die();
		}
	case MOD_CURRENT:
		$site = MOD_CURRENT;
		$libScriptName = 'current';
		$localScriptName = $libScriptName;
		$title = array('cz' => 'Posledn namen hodnoty', 'en' => 'Last measured values');
		break;
	case MOD_LOGOUT:
		if (isset($_GET['access'])) {
			$access = $_GET['access'];
			unset($_GET['access']);
		} else {
			$access = !$_SESSION["lastActivityTime"] ? 'denied' : '';
		}
		session_unset();
		session_destroy();
		$libScriptName = 'logout';
		$title = $access ? array('cz' => 'Neautorizovan pstup', 'en' => 'Access denied') : array('cz' => 'Odhlen z uivatelsk sluby Smarthome', 'en' => 'Smarthomes logout');
		break;
	case MOD_LOGIN:
	default:
		$site = MOD_LOGIN;
		$libScriptName = 'login';
		$title = array('cz' => 'Porovnn prbh mench veliin', 'en' => 'History comparison');
}

$browserTitle = $title[$_SESSION['lang']];
require_once LIBS_PATH.'header.inc.php';
require_once LIBS_PATH."common.lib.php";
require_once "./description.php";
if (!in_array($site, array(MOD_LOGIN, MOD_LOGOUT))) require_once LIBS_PATH.'menu.inc.php';
if (!empty($libScriptName)) require_once LIBS_PATH.$libScriptName.'.lib.php';
if (!empty($localScriptName)) require_once './'.$localScriptName.'.php';
if (!in_array($site, array(MOD_LOGIN, MOD_LOGOUT))) require_once LIBS_PATH.'footer.inc.php';
?>
