<?php
class myDB {
	var $host; # database host
	var $user; # database username
	var $pass; # database password
	var $db;	# our database to select
	var $conn; # internal connection identifier
	var $query; # query string
	var $DB_ERROR; # database error

	function myDB($dbuser = null, $dbpass = null, $dbname = null, $dbhost = null, $dbport = null) {
		$dbhost = $dbhost ? $dbhost : DBHOST;
		$this->host = $dbhost ? $dbhost : "localhost";
		$this->user = !empty($dbuser) ? $dbuser : DBUSER;
		$this->pass = $dbpass ? $dbpass : DBPWD;
		$this->db = $dbname ? $dbname : DBNAME;
		$this->port = $dbport ? $dbport : DBPORT;

		if (!$this->conn = @mysql_connect($this->host, $this->user, $this->pass)) {
			$this->DB_ERROR = mysql_error();
			die("Database connection lost!");
		}
	}

	function getResult($query, $result_type = MYSQL_ASSOC) {
		if (empty($query)) {
			$this->DB_ERROR = 'EMPTY_QUERY';
			return false;
		}

		return new dbResult($this, $query, $result_type);
	}

	# start transaction - not supported
	function Begin() {
	}

	# finish transaction - not supported
	function Commit() {
	}

	# rollback transaction - not supported
	function Rollback() {
	}

	# get next sequence id - don't use (not supported transaction)
	function NextId($sequence) {
	}

	function Delete($table,$key,$id) {
		$query = "DELETE FROM $table WHERE $key = $id;";
		if ($Result = new dbResult($this, $query, MYSQL_ASSOC)) {
			$Result->freeResult();
			return true;
		} else {
			return false;
		}
	}

	function insert($table, $data) {
		$qStr1 = '';
		$qStr2 = '';
		foreach($data as $k => $v) {
			if (!empty($k)) {
				$qStr1 .= "$k, ";
				$qStr2 .= "'$v', ";
			}
		}
		return "INSERT INTO $table (".substr($qStr1, 0, -2).') VALUES ('.substr($qStr2, 0, -2).');';
	}

	function update($table, $data, $condition) {
		$qStr = '';
		foreach($data as $k => $v) {
			if (!empty($k)) {
				$qStr .= "$k='$v', ";
			}
		}
		return "UPDATE $table SET ".substr($qStr, 0, -2).$condition.';';
	}

	function updateTable($table, $data, $key = null) {
		if(!empty($key) && array_key_exists($key, $data)) {
			$chgval = $data[$key];
			if($chgval == 'n') { # we're going to insert new record
				if ($this->getResult(insert($table, $data))) {
					return mysql_insert_id($this->conn); # return new id
				}
			} else {
				# update existing record
				unset($data[$key]);
				if ($this->getResult(update($table, $data, " WHERE $key = '$chgval'"))) {
					return $chgval; # return ID of changed record
				}
			}
		} else {
			if ($this->getResult(insert($table, $data))) { # insert new record without returning new id
				return true; # return true
			}
		};
		# return false by defualt
		return false;
	}

	function close() {
		return mysql_close();
	}

	function getTableStruct($table) {
/*
		$query = "SELECT a.attname AS field_name, t.typname AS field_type FROM pg_attribute a, pg_class c, pg_type t WHERE c.relname = '".$table."' AND a.attnum > 0 AND a.attrelid = c.oid AND a.atttypid = t.oid	ORDER BY a.attnum";

		$Result = $this->getResult($query);
		unset($query);
		$struct = array();
		while($res = $Result->fetchRow()) {
			$struct[$res['field_name']] = $res['field_type'];
		}
		unset($Result, $res);

		return $struct;
*/
	}

}

class dbResult {
	var $DB;
	var $Query;
	var $Result;
	var $ResultType;
	var $CurrentRow;
	var $NumRows;
	var $AffectedRows;

	function dbResult(&$DB, $query, $result_type) {
		$this->DB = &$DB;
		$this->Query = $query;

		if($this->Result) {
			$this->freeResult();
		}

		if (DEBUG == 'db' || DEBUG == 'all') {
			debug($this->Query);
		}

		$this->ResultType = $result_type;
		if(!$this->Result = mysql_db_query($this->DB->db, $this->Query)) {
			$this->DB->DB_ERROR = @mysql_error($this->DB->conn);
			return false;
		}

		$this->NumRows = mysql_num_rows($this->Result); # for SELECT
		$this->AffectedRows = @mysql_affected_rows($this->Result); # for INSERT, UPDATE, DELETE

		return $this;
	}

	function fetchRow() {
		@$this->CurrentRow = mysql_fetch_array($this->Result, $this->ResultType);
		return $this->CurrentRow;
	}

	function getCurrentRow() {
		return $this->CurrentRow;
	}

	function getField($field) {
		if (empty($this->CurrentRow)) {
			$this->fetchRow();
		}
		if (!empty($this->CurrentRow[$field])) {
			return $this->CurrentRow[$field];
		}
		return false;
	}

	function getNumRows() {
		return $this->NumRows;
	}

	function getAffectedRows() {
		return $this->AffectedRows;
	}

	function freeResult() {
		if (!mysql_free_result($this->Result)) {
			$this->DB->DB_ERROR = @mysql_error($this->DB->conn);
			return false;
		}
		$this->Query = null;
		$this->CurrentRow = null;
		$this->NumRows = 0;
		$this->AffectedRows = 0;
		return true;
	}
}
?>